<template>
  <div class="home">
    <AppTitle />
    <div class="control">
      <NavBar />
      <button class="new-project-btn">New Project</button>
    </div>
    <div v-if="getBoardState === ApiRequestState.SUCCESS" class="project-board-wrapper">
      <div v-for="board in projectBoards" :key="board.id">
        <ProjectBoard :board="board" />
      </div>
    </div>
    <div class="control-board">
      <div>Control Panel</div>
      <button @click="createProject">Test WS Create Project</button>
      <button @click="joinRoom">Join Room</button>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue';
import AppTitle from '@/components/AppTitle.vue';
import ProjectBoard from '@/components/ProjectBoard.vue';
import NavBar from '@/components/NavBar.vue';
import useWebsocket from '@/composable/useWebsocket';
import useProject from '@/composable/useProject';
import { ApiRequestState } from '@/utils/RequestState';

export default defineComponent({
  name: 'Home',
  components: {
    NavBar,
    AppTitle,
    ProjectBoard,
  },

  setup() {
    const { openConnection, monitorWsState, socketState, socket } = useWebsocket();
    const { getBoards, getBoardState } = useProject();
    const projectBoards = ref([]);

    onMounted(async () => {
      console.log('Main page Mounted');
      openConnection();
      monitorWsState();
      projectBoards.value = await getBoards();
    });

    function createProject() {
      socket.value?.emit(
        'createProject',
        {
          name: 'Project1',
          description: 'Test',
        },
        (res: any) => console.log(res),
      );
    }

    function joinRoom() {
      socket.value?.emit('joinRoom', null, (res: any) => console.log(res));
    }

    return { socketState, projectBoards, getBoardState, ApiRequestState, createProject, joinRoom };
  },
});
</script>

<style lang="scss" scoped>
.control-board {
  display: flex;
  gap: 10px;
  flex-wrap: wrap;
  padding: 15px;
  font-weight: 600;
  background: #2b30b7;
  width: 400px;
  height: 200px;
  position: absolute;
  right: 0;
  bottom: 0;
  color: whitesmoke;
  border-top-left-radius: 8px;
}

.project-board-wrapper {
  display: flex;
  flex-wrap: wrap;
  gap: 20px;
}

.control {
  display: flex;
  place-items: center;

  button,
  input[type='submit'],
  input[type='reset'] {
    background: none;
    color: inherit;
    border: none;
    padding: 0;
    font: inherit;
    cursor: pointer;
    outline: inherit;
  }

  .new-project-btn {
    height: 35px;
    background: var(--color-primary);
    color: var(--item-background);
    padding: 5px 15px;
    font-size: 14px;
    border-radius: 5px;
    box-shadow: var(--box-shadow);
  }
}
</style>
